#include<stdio.h>
#include<assert.h>
int Prims [3500] = {
2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541,

};
int pqs[3500];

// pos = 3402
int qsum (int num) {
  int res = 0;
  while (num>0) {
    res += num%10;
    num /= 10;    
  }
  return res;
}

bool smithnum (int n) {
  int qs = qsum (n);
  int qf = 0;
  assert (n>1);
  for (int *ip = Prims, *iq=pqs, prim; n>1 ; ip++, iq++) {
    prim = *ip;
    if (prim*prim > n) break;
    // assert (prim!=0);
    if (prim ==0) {
      printf (" \n!!!!  prim, (ip): %d %d\n", prim, ip-Prims);
      return false;
    }
    for (int t = n/prim;  t*prim==n && n>1 ; ) {
      qf += *iq;
      if (qf>qs) return false;
      n = t;
      t = n/prim;
    }
  }
  // assert(n==1);
  return (qf==qs);
} /** smithnum(int) **/

int main() {
  for(int *i1 = Prims, *i2=pqs; i1-Prims <3480; i1++, i2++) {
    *i2 = qsum(*i1);
  }
  for (int i = 1234 ; i<1500; i+=10) {
    printf("%i : %i\n", Prims[i], pqs[i] );
  }
  fflush(stdout);
  printf("-----\n");
  assert(smithnum(9985));
  assert(smithnum(6036));
  for (int num = 4937774, k=0, j=0; num <1000000000; num++) {
    if (smithnum(num)) {
      printf("%i,", num); fflush(stdout);
      if (++k==10) {
	printf("\n");
	k=0;
      }
    }
    if (num%1000000==0) {  printf(" #%i! ",num/1000000);fflush(stdout);}
  }
  return 0;
    
}







